
`timescale 1ns/1ps
module top(clk, rst, sinOk, cosOk, x_o, y_o, x_o1, y_o1, first);
// ports
input clk,rst;
output sinOk,cosOk,first;
output signed[16:0] x_o,y_o;
output signed[16:0] x_o1,y_o1;
// parameter
parameter SIM =0;

// key_rst 
reg [15:0] counter;
reg clk_en;
reg [7:0]delay_rst;
reg reset_temp;
always @(posedge clk)
    if(counter==15'd49999) begin
	   counter <= 15'd0;
	   clk_en <= 1'b1;
	end else begin
	   counter <= counter + 1;
	   clk_en <= 1'b0;	 
	end	
always @(posedge clk) 
    if(clk_en) begin
	   delay_rst <= {delay_rst[6:0],rst};
	end

assign reset_temp = &{delay_rst[5],!delay_rst[4],!delay_rst[3],!delay_rst[2],!delay_rst[1],!delay_rst[0]};
assign cordic_rst = SIM ? rst : ~reset_temp;



reg [16:0] x_o1,y_o1;

wire [16:0] x_o,y_o;
wire [16:0] theta_o;

reg [16:0]memx_o[0:90]={`include "o_cos.txt"};
reg [16:0]memy_o[0:90]={`include "o_sin.txt"};
reg [16:0]memtheta_i[0:90]={`include "o_theta.txt"};

reg  [16:0] x_i,y_i;
reg  [16:0] theta_i;

reg [6:0]ad;
wire    sinOk = x_o1 == x_o;
wire    cosOk = y_o1 == y_o;

always@(posedge clk ) begin
    if(cordic_rst)
        ad<=0;
    else if(ad == 90)
        ad<=ad;
    else
        ad<=ad + 1;
end

always@(posedge clk ) begin
    if(cordic_rst)begin
        x_i<=0;
        y_i<=0;
        theta_i<=17'd0;
    end else begin
        x_i<=17'd19898;
        y_i<=0;
        theta_i<=memtheta_i[ad];
    end
end

reg [4:0]cnt;
wire first = cnt == 16;
wire isCntOnver = cnt == 16;
always@(posedge clk) begin
    if(cordic_rst)
        cnt<=4'd0;
    else if(isCntOnver)
        cnt<=cnt;
    else
        cnt<=cnt+1;
end



reg [6:0]cnt1;
always@(posedge clk) begin
    if(cordic_rst)
        cnt1<=7'd0;
    else if(cnt1==7'd106)
        cnt1<=cnt1;
    else
        cnt1<=cnt1+1;
end

always@(posedge clk ) begin
    if(cordic_rst) begin  
        x_o1<=0;
        y_o1<=0;
    end
    if(isCntOnver==1) begin
        x_o1<=memx_o[cnt1-16];
        y_o1<=memy_o[cnt1-16];
    end 
end

CORDIC_Top uut(
    .clk     (clk),
    .rst     (cordic_rst),
    .x_i     (x_i),
    .y_i     (y_i),
    .theta_i (theta_i),
    .x_o     (x_o),
    .y_o     (y_o),
    .theta_o (theta_o)
);

endmodule