`timescale 1ns/1ps
// vector_iterate_degree
module top(clk, rst, rtheta, gtheta, cnt_over);

input clk;
input rst;
output [16:0] rtheta;
output [16:0] gtheta;
output cnt_over;

parameter SIM =0;
wire cordic_rst;
// key_rst 
reg [15:0] counter;
reg clk_en;
reg [7:0]delay_rst;
reg reset_temp;
always @(posedge clk)
    if(counter==15'd49999) begin
	   counter <= 15'd0;
	   clk_en <= 1'b1;
	end else begin
	   counter <= counter + 1;
	   clk_en <= 1'b0;	 
	end	
always @(posedge clk) 
    if(clk_en) begin
	   delay_rst <= {delay_rst[6:0],rst};
	end

assign reset_temp = &{delay_rst[5],!delay_rst[4],!delay_rst[3],!delay_rst[2],!delay_rst[1],!delay_rst[0]};
assign cordic_rst = SIM ? rst : ~reset_temp;

//golden
reg  [16:0] gtheta=0;
reg [16:0]memtheta_i[0:90]={`include "o_theta.txt"};

//revise
reg [16:0] gx_r =0, gy_r =0;
reg [16:0]memx_o[0:90]={`include "o_cos.txt"};
reg [16:0]memy_o[0:90]={`include "o_sin.txt"};

//ip cordic
wire  [16:0]      theta_i=0;
wire [16:0]       x_o,y_o;
wire cnt_last;
//counter
reg [4:0]   cnt =0;
reg         cnt_startDly =0;
wire        cnt_over;
wire        cnt_start;

//address
wire        addr_over;
reg [7:0] addr=0;


//copmare
reg sinOk_r =1;
wire sinCmpOk;
//===========================================================================



//counter
assign cnt_over         = cnt == 18;
assign cnt_start        = cnt == 0;
assign cnt_last         = cnt == 17;

//copmare
assign sinCmpOk   =cnt_over & (!addr_over) ? (gtheta == rtheta & sinOk_r) : sinOk_r;

//address
assign addr_over  =addr == 90;

//=============================================================================
//counter
always@(posedge clk)begin
    if(cordic_rst)
        cnt <= 0;
    else if(cnt_over)
        cnt <= 0;
    else
        cnt <= cnt +1;
end

always@(posedge clk)begin
    if(cordic_rst)
        cnt_startDly <= 0;
    else
        cnt_startDly <= cnt_start;
end

//revise
always@(posedge clk)begin
    if(cordic_rst) begin
        gx_r <= 0;
        gy_r <= 0;
    end
    else if(cnt_start) begin
        gx_r <= memx_o[addr];
        gy_r <= memy_o[addr];
    end
end


//golden
always@(posedge clk)begin
    if(cordic_rst)begin
        gtheta <= 0;
    end else if(cnt_last) begin
        gtheta <= memtheta_i[addr];
        end
end


//copmare
always@(posedge clk)begin
    if(cordic_rst)begin
        sinOk_r <= 1;
    end else begin
        sinOk_r <= sinCmpOk;
    end
end

//address
always@(posedge clk)begin
    if(cordic_rst)
        addr <= 0;
    else if(cnt_over)
        if(addr_over)
            addr <= addr;
        else
            addr <= addr +1;
end

//degree_iterate_vector
CORDIC_Top uut(
    .clk     (clk),
    .init    (cnt_startDly),
    .rst     (cordic_rst),
    .x_i     (gx_r),
    .y_i     (gy_r),
    .theta_i (theta_i),
    .x_o     (x_o),
    .y_o     (y_o),
    .theta_o (rtheta)
);

endmodule